# encoding: UTF-8
require 'spec_helper'

describe Suppliers::SectionsController, type: :controller do
  before :each do
    @supplier = Supplier.find_by_email('supplier@mozo.bar') || create(:supplier, :confirmed)
    sign_in @supplier
  end

  def valid_attributes
    {title: 'Terrace'}
  end

  def invalid_attributes
    {title: ''}
  end

  describe "GET #index" do
    it "does not include sections from another supplier" do
      base_section = @supplier.sections.first
      section1 = create :section, supplier: @supplier
      section2 = create :section
      get :index
      assigns(:sections).map(&:id).sort.should == [base_section.id, section1.id].sort
    end

    it "should render without errors when no objects are present" do
      get :index
      expect{ render_template :index }.not_to raise_error
    end
  end

  describe "GET #show" do
    it "assigns the requested section to @section" do
      section = create :section, supplier: @supplier
      get :show, id: section
      assigns(:section).should eq(section)
    end

    it "should not display a section of another supplier" do
      section = create :section
      get :show, id: section
      response.status.should == 404
    end

    it "renders the #show view" do
      section = create :section, supplier: @supplier
      get :show, id: section
      response.should render_template :tables_view
    end
  end

  describe "GET #new" do
    it "assigns a new section to @section" do
      get :new
      assigns(:section).should be_a Section
    end

    it "renders the #show view" do
      get :new
      response.should render_template :new
    end
  end

  describe "POST #create" do
    context "with valid attributes" do
      it "creates a new section" do
        expect{
          post :create, section: valid_attributes
        }.to change(Section, :count).by(1)
      end

      it "redirects to the new section" do
        post :create, section: valid_attributes.merge(title: 'Created section 45')
        response.should redirect_to [:suppliers, Section.find_by_title('Created section 45')]
      end

      it "should not be possible to create a section for another supplier" do
        supplier2 = create :supplier
        expect{ post :create, section: valid_attributes.merge(title: 'Trying to hack', supplier_id: supplier2.id) }.to raise_error
        expect( Section.find_by_title 'Trying to hack' ).not_to be_present
      end
    end

    context "with invalid attributes" do
      it "does not save the new section" do
        expect{
          post :create, section: invalid_attributes
        }.to_not change(Section, :count)
      end

      it "re-renders the new method" do
        post :create, section: invalid_attributes
        response.should render_template :new
      end
    end
  end

  describe 'PUT update' do
    before :each do
      @section = create :section, supplier: @supplier
    end

    context "valid attributes" do
      it "located the requested section" do
        put :update, id: @section, section: valid_attributes
        @section.reload
        assigns(:section).should eq(@section)
      end

      it "changes @section's attributes" do
        put :update, id: @section, section: valid_attributes.merge(title: "ChangedByTest")
        @section.reload
        expect( @section.title ).to eq "ChangedByTest"
      end

      it "redirects to the updated section" do
        put :update, id: @section, section: valid_attributes
        response.should redirect_to [:suppliers, @section]
      end

      it "should not be possible to update a section to another supplier" do
        supplier2 = create :supplier
        expect{ put :update, id: @section, section: valid_attributes.merge(title: "Trying to hack", supplier_id: supplier2.id) }.to raise_error
        @section.reload
        @section.supplier_id.should == @supplier.id
      end

      it "should not be possible to update a section of another supplier" do
        section = create :section, title: 'Other supplier section'
        put :update, id: section, section: {title: "Trying to hack"}
        section.reload
        section.title.should == 'Other supplier section'
      end
    end

    context "invalid attributes" do
      it "locates the requested section" do
        put :update, id: @section, section: invalid_attributes
        assigns(:section).should eq(@section)
      end

      it "re-renders the edit method" do
        put :update, id: @section, section: invalid_attributes
        response.should render_template :edit
      end
    end
  end

  describe 'DELETE destroy' do
    before :each do
      @section = create :section, supplier: @supplier
    end

    it "deletes the section" do
      expect{
        delete :destroy, id: @section
      }.to change(Section, :count).by(-1)
    end

    it "redirects to sections#index" do
      delete :destroy, id: @section
      response.should redirect_to [:suppliers, :sections]
    end

    it "should not be possible to delete a section of another supplier" do
      section = create :section
      expect{
        delete :destroy, id: section
      }.to_not change(Section, :count)
    end
  end

  describe 'GET #manage_tables' do
    pending "Add tests"
  end

  describe 'GET #tables_view' do
    pending "Add tests"
  end

  describe 'POST #add_tables' do
    pending "Add tests"
  end

  describe 'POST #arrange_tables' do
    pending "Add tests"
  end
end
